import type { Program } from "./program.js";
import { JsSourceFileNode, Node, Sym, SymbolFlags, SymbolTable, TypeSpecScriptNode } from "./types.js";
declare const SymbolTable: {
    new (source?: SymbolTable): {
        duplicates: Map<Sym, Set<Sym>>;
        /** {@inheritdoc MutableSymboleTable} */
        include(source: SymbolTable, parentSym?: Sym): void;
        set(key: string, value: Sym): /*elided*/ any;
        clear(): void;
        delete(key: string): boolean;
        forEach(callbackfn: (value: Sym, key: string, map: Map<string, Sym>) => void, thisArg?: any): void;
        get(key: string): Sym | undefined;
        has(key: string): boolean;
        readonly size: number;
        entries(): MapIterator<[string, Sym]>;
        keys(): MapIterator<string>;
        values(): MapIterator<Sym>;
        [Symbol.iterator](): MapIterator<[string, Sym]>;
        readonly [Symbol.toStringTag]: string;
    };
    groupBy<K, T>(items: Iterable<T>, keySelector: (item: T, index: number) => K): Map<K, T[]>;
    readonly [Symbol.species]: MapConstructor;
};
export interface Binder {
    bindSourceFile(script: TypeSpecScriptNode): void;
    bindJsSourceFile(sourceFile: JsSourceFileNode): void;
}
export declare function createSymbolTable(source?: SymbolTable): SymbolTable;
export declare function createBinder(program: Program): Binder;
export declare function createSymbol(node: Node | undefined, name: string, flags: SymbolFlags, parent?: Sym, value?: any): Sym;
/**
 * Get the node attached to this symbol.
 * If a declaration symbol get the first one `.declarations[0]`
 * Otherwise get `.node`
 */
export declare function getSymNode(sym: Sym): Node;
export {};
//# sourceMappingURL=binder.d.ts.map