import { CompilerOptions } from "../../../options.js";
import { CompilerHost, Diagnostic } from "../../../types.js";
export interface CompileCliArgs {
    path?: string;
    pretty?: boolean;
    /** Print statistics about the compilation(Task duration, types created, etc.) */
    stats?: boolean;
    "output-dir"?: string;
    "output-path"?: string;
    nostdlib?: boolean;
    options?: string[];
    import?: string[];
    watch?: boolean;
    emit?: string[];
    trace?: string[];
    debug?: boolean;
    config?: string;
    "warn-as-error"?: boolean;
    "list-files"?: boolean;
    "no-emit"?: boolean;
    "dry-run"?: boolean;
    "ignore-deprecated"?: boolean;
    args?: string[];
}
export declare function getCompilerOptions(host: CompilerHost, entrypoint: string, cwd: string, args: CompileCliArgs, env: Record<string, string | undefined>): Promise<[CompilerOptions | undefined, readonly Diagnostic[]]>;
//# sourceMappingURL=args.d.ts.map