import { getDirectoryPath } from "./path-utils.js";
const emittedFilesPaths = [];
export function flushEmittedFilesPaths() {
    return emittedFilesPaths.splice(0, emittedFilesPaths.length);
}
/**
 * Helper to emit a file.
 * @param program TypeSpec Program
 * @param options File Emitter options
 */
export async function emitFile(program, options) {
    // ensure path exists
    const outputFolder = getDirectoryPath(options.path);
    await program.host.mkdirp(outputFolder);
    const content = options.newLine && options.newLine === "crlf"
        ? options.content.replace(/(\r\n|\n|\r)/gm, "\r\n")
        : options.content;
    emittedFilesPaths.push(options.path);
    return await program.host.writeFile(options.path, content);
}
//# sourceMappingURL=emitter-utils.js.map