import { parse } from "./parser.js";
import { typespecPrinter } from "./print/index.js";
export const defaultOptions = {};
export const languages = [
    {
        name: "TypeSpec",
        parsers: ["typespec"],
        extensions: [".tsp"],
        vscodeLanguageIds: ["typespec"],
    },
];
const TypeSpecParser = {
    parse,
    astFormat: "typespec-format",
    locStart(node) {
        return node.pos;
    },
    locEnd(node) {
        return node.end;
    },
};
export const parsers = {
    typespec: TypeSpecParser,
};
export const printers = {
    "typespec-format": typespecPrinter,
};
//# sourceMappingURL=index.js.map