import { $discriminator, $doc, $encode, $encodedName, $error, $errorsDoc, $example, $format, $friendlyName, $inspectType, $inspectTypeName, $key, $maxItems, $maxLength, $maxValue, $maxValueExclusive, $mediaTypeHint, $minItems, $minLength, $minValue, $minValueExclusive, $opExample, $overload, $pattern, $returnsDoc, $secret, $service, $summary, $tag, $withOptionalProperties, $withPickedProperties, $withoutDefaultValues, $withoutOmittedProperties, discriminatedDecorator, } from "./decorators.js";
import { continuationTokenDecorator, firstLinkDecorator, lastLinkDecorator, listDecorator, nextLinkDecorator, offsetDecorator, pageIndexDecorator, pageItemsDecorator, pageSizeDecorator, prevLinkDecorator, } from "./paging.js";
import { $defaultVisibility, $invisible, $parameterVisibility, $removeVisibility, $returnTypeVisibility, $visibility, $withDefaultKeyVisibility, $withLifecycleUpdate, $withUpdateableProperties, $withVisibility, $withVisibilityFilter, } from "./visibility.js";
/** @internal */
export const $decorators = {
    TypeSpec: {
        encode: $encode,
        mediaTypeHint: $mediaTypeHint,
        doc: $doc,
        withOptionalProperties: $withOptionalProperties,
        withUpdateableProperties: $withUpdateableProperties,
        withoutOmittedProperties: $withoutOmittedProperties,
        withPickedProperties: $withPickedProperties,
        withoutDefaultValues: $withoutDefaultValues,
        summary: $summary,
        returnsDoc: $returnsDoc,
        errorsDoc: $errorsDoc,
        service: $service,
        error: $error,
        format: $format,
        pattern: $pattern,
        minLength: $minLength,
        maxLength: $maxLength,
        minItems: $minItems,
        maxItems: $maxItems,
        minValue: $minValue,
        maxValue: $maxValue,
        minValueExclusive: $minValueExclusive,
        maxValueExclusive: $maxValueExclusive,
        secret: $secret,
        tag: $tag,
        friendlyName: $friendlyName,
        key: $key,
        overload: $overload,
        encodedName: $encodedName,
        discriminated: discriminatedDecorator,
        discriminator: $discriminator,
        example: $example,
        opExample: $opExample,
        inspectType: $inspectType,
        inspectTypeName: $inspectTypeName,
        visibility: $visibility,
        removeVisibility: $removeVisibility,
        invisible: $invisible,
        defaultVisibility: $defaultVisibility,
        withVisibility: $withVisibility,
        withVisibilityFilter: $withVisibilityFilter,
        withLifecycleUpdate: $withLifecycleUpdate,
        withDefaultKeyVisibility: $withDefaultKeyVisibility,
        parameterVisibility: $parameterVisibility,
        returnTypeVisibility: $returnTypeVisibility,
        list: listDecorator,
        offset: offsetDecorator,
        pageIndex: pageIndexDecorator,
        pageSize: pageSizeDecorator,
        pageItems: pageItemsDecorator,
        continuationToken: continuationTokenDecorator,
        nextLink: nextLinkDecorator,
        prevLink: prevLinkDecorator,
        firstLink: firstLinkDecorator,
        lastLink: lastLinkDecorator,
    },
};
export const namespace = "TypeSpec";
//# sourceMappingURL=tsp-index.js.map