import { isRecordModelType } from "../../core/type-utils.js";
import { defineKit } from "../define-kit.js";
defineKit({
    record: {
        is(type) {
            return (type.entityKind === "Type" &&
                type.kind === "Model" &&
                isRecordModelType(this.program, type) &&
                type.properties.size === 0);
        },
        getElementType(type) {
            if (!this.record.is(type)) {
                throw new Error("Type is not a record.");
            }
            return type.indexer.value;
        },
        create(elementType) {
            return this.model.create({
                name: "Record",
                properties: {},
                indexer: {
                    key: this.builtin.string,
                    value: elementType,
                },
            });
        },
    },
});
//# sourceMappingURL=record.js.map